
RM ?= rm -f

CXX = clang++

SRC = \
	Vec2.cpp \
	Vec3.cpp \
	Vec4.cpp \
	Mat4x4.cpp \
	Quat.cpp \
	Vec2i.cpp \
	Vec3i.cpp \
	Vec4i.cpp \
	Debug.cpp
SRCS = $(addprefix src/, $(SRC))

OBJS = $(addprefix obj/, $(SRC:.cpp=.o))
DEPS = $(addprefix dep/, $(SRC:.cpp=.d))

CPPFLAGS = -Wall -Wextra -Werror -Ofast -march=native -flto -I include -std=c++11
LDFLAGS=
LDLIBS=


NAME = libmmatrix.a
.PHONY: all clean fclean run debug re run


default:all


all: $(NAME)

$(NAME): $(DEPS) $(OBJS)
	ar -rcs $(NAME) $(OBJS)
	ranlib $(NAME)
#	$(CXX) $(LDFLAGS) -o $(NAME) $(OBJS) $(LDLIBS)

obj/%.o: src/%.cpp
	$(CXX) -o $@ -c $< $(CPPFLAGS)
dep/%.d: src/%.cpp
	@echo "generate $@"
	@set -e; $(RM) $@; \
	$(CXX) -MM $(CPPFLAGS) $< > $@.$$$$; \
		sed 's,\($*\)\.o[ :]*,obj/\1.o $@ : ,g' < $@.$$$$ >> $@; \
		$(RM) $@.$$$$

depend: $(DEPS)

clean:
	$(RM) $(OBJS)
	$(RM) $(DEPS)
fclean:clean
	$(RM) $(NAME)
	$(RM) .depend
re:fclean all
run:
	./$(NAME) $(ARGS)
debug:all run

-include $(DEPS)